//########################
//InDesignCS3にPDFを配置してコンタクトシートを作成します。
//PDFの配置時のフィット方法も設定できます。
//ドキュメントを開いて実行してください。
//たけうちとおる
//########################


//ダイアログ表示のおまじない
app.scriptPreferences.userInteractionLevel=1699311169;
////////下記が初期値になりますので編集してください。//////////
//配置スタートページ
var startpage = 1;
//PDFのスタートページ
var pdfstartpage = 1;
//トリミング　バウンディングボックス=0　アート=1 　トリミング=2　トンボ=3　裁ち落とし=4　メディア=5
var pdfplaceopt = 0;
//天の空き
var ten = 3;
//左右センター=0　小口の値=1
var sayu = 0;
//小口の空き
var cogu = 3;
//X方向の繰り返し
var repeat_x = 3;
//X方向の空き
var aki_x = 5
//Y方向の繰り返し
var repeat_y = 5;
//Y方向の空き
var aki_y = 5;
//左ページPDFの水平パーセント
var myPerW = 100;
//左ページPDFの垂直パーセント
var myPerH = 100;
//左ページPDF配置オプション　比率を指定してセンター=0　内容をフレームに合わせる=1　内容を縦横比率に応じて合わせる（短辺）=2　フレームに均等に流し込む（長辺）
var pdf_fitopt = 0;
//画像の幅
var rect_w = 50;
//画像の高さ
var rect_h = 40;
//画像とキャプションの空き
var cap_aki = 1;
//キャプションの高さ
var cap_h = 5;
//段落スタイル
var capstyle = 0;
var placepage = startpage;
var styleList = new Array();
main();
function main(){
	if (app.documents.length == 0){
			alert("ドキュメントを開いて実行してください。");
			return;
	}
	//ダイアログを作成する
	var mypt = 2.83465;
	styleList = app.activeDocument.paragraphStyles;
	var stylenameList = new Array(styleList.length);
	for(s = 0; s < styleList.length; s++){
		stylenameList[s] = styleList[s].name;
	}
	myDialog = app.dialogs.add({name:"PDFをInDesignに配置します。"});
	with(myDialog){
		with(dialogColumns.add()){
			with(borderPanels.add()){
				with (dialogColumns.add()){
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"配置スタートページ"});
						var d_startpage = integerEditboxes.add({editValue:startpage,minimumValue:1,maximumValue:1000});
						staticTexts.add({staticLabel:"　　PDFのスタートページ"});
						var d_pdfstartpage = integerEditboxes.add({editValue:pdfstartpage,minimumValue:1,maximumValue:1000});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"トリミング"});
						var Listpdfplaceopt = new Array("バウンディングボックス","アート","トリミング","トンボ","裁ち落とし","メディア");
						var d_pdfplaceopt = dropdowns.add({stringList:Listpdfplaceopt, selectedIndex:pdfplaceopt, minWidth:120});
					}
				}
			}
			with(borderPanels.add()){
				with (dialogColumns.add()){
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"天と小口の余白"});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"　天"});
						var d_ten = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:ten *mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
					}
					with (dialogRows.add()){
						var List_x = new Array("左右センター","小口の空きを指定");
						var d_sayu = dropdowns.add({stringList:List_x, selectedIndex:sayu, minWidth:120});
						staticTexts.add({staticLabel:"小口"});
						var d_cogu = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:cogu *mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
					}
				}
				with (dialogColumns.add()){
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"　繰り返し"});
					}
					var repeat_ary = new Array("1","2","3","4","5","6","7","8","9","10");
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"　X方向"});
						var d_repeat_x = integerComboboxes.add({editValue:repeat_x,minimumValue:0,maximumValue:100,stringList:repeat_ary});
						staticTexts.add({staticLabel:"　X方向の空き"});
						var d_aki_x = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:aki_x *mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"　Y方向"});
						var d_repeat_y = integerComboboxes.add({editValue:repeat_y,minimumValue:1,maximumValue:100,stringList:repeat_ary});
						staticTexts.add({staticLabel:"　Y方向の空き"});
						var d_aki_y = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:aki_y *mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
					}
				}
			}
			with(borderPanels.add()){
				with (dialogColumns.add()){
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"小組みの設定"});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"配置方法"});
					}
					with (dialogRows.add()){
						var Listpdfplaceopt = new Array("比率を指定してセンター", "内容をフレームに合わせる", "内容を縦横比率に応じて合わせる（短辺）","フレームに均等に流し込む（長辺）");
						var d_pdf_fitopt = dropdowns.add({stringList:Listpdfplaceopt, selectedIndex:pdf_fitopt, minWidth:120});
					}
					with (dialogRows.add()){
						var Listpercent = new Array("100", "90", "80", "70", "60", "50", "40", "30", "20", "10", "0");
						staticTexts.add({staticLabel:"Wの変倍率"});
						var d_myPerW = percentComboboxes.add({editValue:myPerW,minimumValue:0,maximumValue:1000,stringList:Listpercent});
						staticTexts.add({staticLabel:"　Hの変倍率"});
						var d_myPerH = percentComboboxes.add({editValue:myPerH,minimumValue:0,maximumValue:1000,stringList:Listpercent});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"　画像の幅"});
						var d_rect_w = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:rect_w *mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
						staticTexts.add({staticLabel:"　画像の高さ"});
						var d_rect_h = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:rect_h *mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"　画像とキャプションの空き"});
						var d_cap_aki = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:cap_aki *mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"　キャプションの高さ"});
						var d_cap_h = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:cap_h *mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"　キャプションのスタイル"});
						var d_capstyle = dropdowns.add({stringList:stylenameList, selectedIndex:capstyle, minWidth:120});
					}
				}
			}
			staticTexts.add({staticLabel:"(C)2009 Toru Takeuchi このスクリプトはフリーウェアです。"});
		}
	}
	var myReturn = myDialog.show();
	//ここから処理を行う
	if (myReturn == true){
		startpage = d_startpage.editValue;
		pdfstartpage = d_pdfstartpage.editValue;
		//トリミング　バウンディングボックス=0　アート=1 　トリミング=2　トンボ=3　裁ち落とし=4　メディア=5
		//editContents
		pdfplaceopt = d_pdfplaceopt.selectedIndex;
		ten = d_ten.editValue/mypt;
		sayu = d_sayu.selectedIndex;
		cogu = d_cogu.editValue/mypt;
		repeat_x = d_repeat_x.editValue;
		aki_x = d_aki_x.editValue/mypt;
		repeat_y = d_repeat_y.editValue;
		aki_y = d_aki_y.editValue/mypt;

		myPerW = d_myPerW.editValue;
		myPerH = d_myPerH.editValue;
		pdf_fitopt = d_pdf_fitopt.selectedIndex;
		
		rect_w = d_rect_w.editValue/mypt;
		rect_h = d_rect_h.editValue/mypt;
		cap_aki = d_cap_aki.editValue/mypt;
		cap_h = d_cap_h.editValue/mypt;
		capstyle = d_capstyle.selectedIndex;
		
		myDialog.destroy();
		indd_select_pdf();
	}
	else{
		myDialog.destroy();
	}
}

function indd_select_pdf(){
	if (app.documents.length != 0){
		var selFile = File.openDialog("PDFファイルを選択してください");
		//トリミング　バウンディングボックス=0　アート=1 　トリミング=2　トンボ=3　裁ち落とし=4　メディア=5
		if(pdfplaceopt == 0){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_CONTENT;	//1131573315	バウンディングボックス
		}else if(pdfplaceopt == 1){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_ART;//アート
		}else if(pdfplaceopt == 2){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_PDF;//	1131573328	トリミング
		}else if(pdfplaceopt == 3){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_TRIM;//	1131573332	トンボ
		}else if(pdfplaceopt == 4){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_BLEED;//	1131573314	裁ち落とし
		}else if(pdfplaceopt == 5){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_MEDIA;//	1131573325	メディア
		}
		var loopflg = true;
		
		var pagebounds = app.activeDocument.pages[0].bounds;
		var pageW = pagebounds[3] - pagebounds[1];
		var hanW = (rect_w*repeat_x)+(aki_x*(repeat_x-1));
		if(sayu == 0){
				cogu = (pageW  - hanW) / 2;
		}
		var pdfpage = pdfstartpage;
		var startX = 0;
		var startY = 0;
		placepage = startpage;
		while (loopflg){
			for(my_y = 0;my_y < repeat_y;my_y++){
				for(my_x = 0;my_x < repeat_x;my_x++){
					loopflg = placepdf(selFile,placepage,pdfpage,my_y,my_x,hanW);
					pdfpage++;
					if(loopflg == false){break;}
				}
				if(loopflg == false){break;}
			}
			placepage++;
		}
	}
}
function placepdf(selFile,placepage,pdfpage,my_y,my_x,hanW){
	app.pdfPlacePreferences.pageNumber = pdfpage;
	if(app.activeDocument.pages.length < placepage){
		var pageObj = app.activeDocument.pages.add();
	}else{
		var pageObj = app.activeDocument.pages[placepage-1];
	}
	var rectObj = pageObj.rectangles.add();
	rectObj.strokeWeight = 0;
	var rectbounds = pageObj.bounds;
	if(pageObj.side == PageSideOptions.rightHand){
		//[Y1,X1,Y2,X2]//(top,left,bottom,right)
		rectbounds[0]=rectbounds[0]+ten+rect_h*my_y+aki_y*my_y+cap_aki*my_y+cap_h*my_y;
		rectbounds[1]=rectbounds[3]-hanW-cogu+rect_w*my_x+aki_x*my_x;
		rectbounds[2]=rectbounds[0]+rect_h;
		rectbounds[3]=rectbounds[1]+rect_w;
	}else{
		//[Y1,X1,Y2,X2]
		rectbounds[0]=rectbounds[0]+ten+rect_h*my_y+aki_y*my_y+cap_aki*my_y+cap_h*my_y;
		rectbounds[1]=rectbounds[1]+cogu+rect_w*my_x+aki_x*my_x;
		rectbounds[2]=rectbounds[0]+rect_h;
		rectbounds[3]=rectbounds[1]+rect_w;
	}
	rectObj.geometricBounds = rectbounds;
	var pdfobj = rectObj.place(selFile);
	rectObj.allGraphics[0].verticalScale = myPerW;
	rectObj.allGraphics[0].horizontalScale = myPerH;
	if(pdf_fitopt == 0){
		var myfitopt = FitOptions.CENTER_CONTENT;
	}else if(pdf_fitopt == 1){
		var myfitopt = FitOptions.CONTENT_TO_FRAME;
	}else if(pdf_fitopt == 2){
		var myfitopt = FitOptions.PROPORTIONALLY;
	}else if(pdf_fitopt == 3){
		var myfitopt = FitOptions.FILL_PROPORTIONALLY;
	}
	rectObj.fit (myfitopt);
	rectObj.fit (FitOptions.CENTER_CONTENT);
	var placedpdfpage = rectObj.allGraphics[0].pdfAttributes.pageNumber;
	if(cap_h > 0){
		var tfObj = pageObj.textFrames.add();
		tfObj.geometricBounds = [rectbounds[0]+rect_h+cap_aki,rectbounds[1],rectbounds[0]+rect_h+cap_aki+cap_h,rectbounds[3]];
		tfObj.contents = selFile.displayName + "　ページ：" + String(placedpdfpage);
		tfObj.paragraphs[0].applyParagraphStyle (styleList[capstyle]);
	}
	if(placedpdfpage != pdfpage){
		rectObj.remove();
		if(cap_h > 0){
			tfObj.remove();
		}
		return false;
	}
	return true;
}